import { Identifier, ValueExpression, LogicalExpression } from "../NCalc/Domain";
import { ATN } from "antlr4ts/atn/ATN";
import { FailedPredicateException } from "antlr4ts/FailedPredicateException";
import { Parser } from "antlr4ts/Parser";
import { ParserRuleContext } from "antlr4ts/ParserRuleContext";
import { TerminalNode } from "antlr4ts/tree/TerminalNode";
import { Token } from "antlr4ts/Token";
import { TokenStream } from "antlr4ts/TokenStream";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { NCalcListener } from "./NCalcListener";
import { NCalcVisitor } from "./NCalcVisitor";
export declare class NCalcParser extends Parser {
    static readonly T__0 = 1;
    static readonly T__1 = 2;
    static readonly T__2 = 3;
    static readonly T__3 = 4;
    static readonly T__4 = 5;
    static readonly T__5 = 6;
    static readonly T__6 = 7;
    static readonly T__7 = 8;
    static readonly T__8 = 9;
    static readonly T__9 = 10;
    static readonly T__10 = 11;
    static readonly T__11 = 12;
    static readonly T__12 = 13;
    static readonly T__13 = 14;
    static readonly T__14 = 15;
    static readonly T__15 = 16;
    static readonly T__16 = 17;
    static readonly T__17 = 18;
    static readonly T__18 = 19;
    static readonly T__19 = 20;
    static readonly T__20 = 21;
    static readonly T__21 = 22;
    static readonly T__22 = 23;
    static readonly T__23 = 24;
    static readonly T__24 = 25;
    static readonly T__25 = 26;
    static readonly T__26 = 27;
    static readonly T__27 = 28;
    static readonly NOT = 29;
    static readonly TRUE = 30;
    static readonly FALSE = 31;
    static readonly AND = 32;
    static readonly OR = 33;
    static readonly ID = 34;
    static readonly FLOAT = 35;
    static readonly INTEGER = 36;
    static readonly STRING = 37;
    static readonly DATETIME = 38;
    static readonly NAME = 39;
    static readonly EXPONENT = 40;
    static readonly WS = 41;
    static readonly RULE_ncalcExpression = 0;
    static readonly RULE_logicalExpression = 1;
    static readonly RULE_conditionalExpression = 2;
    static readonly RULE_booleanExpression = 3;
    static readonly RULE_relationalExpression = 4;
    static readonly RULE_shiftExpression = 5;
    static readonly RULE_additiveExpression = 6;
    static readonly RULE_multiplicativeExpression = 7;
    static readonly RULE_unaryExpression = 8;
    static readonly RULE_exponentialExpression = 9;
    static readonly RULE_primaryExpression = 10;
    static readonly RULE_value = 11;
    static readonly RULE_identifier = 12;
    static readonly RULE_expressionList = 13;
    static readonly RULE_arguments = 14;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    protected createFailedPredicateException(predicate?: string, message?: string): FailedPredicateException;
    BS: string;
    ExtractString(text: string): string;
    Errors: any[];
    GetExpression(): any;
    constructor(input: TokenStream);
    ncalcExpression(): NcalcExpressionContext;
    logicalExpression(): LogicalExpressionContext;
    conditionalExpression(): ConditionalExpressionContext;
    booleanExpression(): BooleanExpressionContext;
    relationalExpression(): RelationalExpressionContext;
    shiftExpression(): ShiftExpressionContext;
    additiveExpression(): AdditiveExpressionContext;
    multiplicativeExpression(): MultiplicativeExpressionContext;
    unaryExpression(): UnaryExpressionContext;
    exponentialExpression(): ExponentialExpressionContext;
    primaryExpression(): PrimaryExpressionContext;
    value(): ValueContext;
    identifier(): IdentifierContext;
    expressionList(): ExpressionListContext;
    arguments(): ArgumentsContext;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
export declare class NcalcExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _logicalExpression: LogicalExpressionContext;
    logicalExpression(): LogicalExpressionContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class LogicalExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: ConditionalExpressionContext;
    _middle: ConditionalExpressionContext;
    _right: ConditionalExpressionContext;
    conditionalExpression(): ConditionalExpressionContext[];
    conditionalExpression(i: number): ConditionalExpressionContext;
    WS(): TerminalNode[];
    WS(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class ConditionalExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: BooleanExpressionContext;
    _right: BooleanExpressionContext;
    booleanExpression(): BooleanExpressionContext[];
    booleanExpression(i: number): BooleanExpressionContext;
    AND(): TerminalNode[];
    AND(i: number): TerminalNode;
    OR(): TerminalNode[];
    OR(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class BooleanExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: RelationalExpressionContext;
    _right: RelationalExpressionContext;
    relationalExpression(): RelationalExpressionContext[];
    relationalExpression(i: number): RelationalExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class RelationalExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: ShiftExpressionContext;
    _right: ShiftExpressionContext;
    shiftExpression(): ShiftExpressionContext[];
    shiftExpression(i: number): ShiftExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class ShiftExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: AdditiveExpressionContext;
    _right: AdditiveExpressionContext;
    additiveExpression(): AdditiveExpressionContext[];
    additiveExpression(i: number): AdditiveExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class AdditiveExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: MultiplicativeExpressionContext;
    _right: MultiplicativeExpressionContext;
    multiplicativeExpression(): MultiplicativeExpressionContext[];
    multiplicativeExpression(i: number): MultiplicativeExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class MultiplicativeExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: UnaryExpressionContext;
    _right: UnaryExpressionContext;
    unaryExpression(): UnaryExpressionContext[];
    unaryExpression(i: number): UnaryExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class UnaryExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _exponentialExpression: ExponentialExpressionContext;
    exponentialExpression(): ExponentialExpressionContext | undefined;
    WS(): TerminalNode[];
    WS(i: number): TerminalNode;
    NOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class ExponentialExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _left: PrimaryExpressionContext;
    _right: UnaryExpressionContext;
    primaryExpression(): PrimaryExpressionContext;
    unaryExpression(): UnaryExpressionContext[];
    unaryExpression(i: number): UnaryExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class PrimaryExpressionContext extends ParserRuleContext {
    val: LogicalExpression;
    _logicalExpression: LogicalExpressionContext;
    _expr: ValueContext;
    _identifier: IdentifierContext;
    _arguments: ArgumentsContext;
    logicalExpression(): LogicalExpressionContext | undefined;
    value(): ValueContext | undefined;
    identifier(): IdentifierContext | undefined;
    arguments(): ArgumentsContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class ValueContext extends ParserRuleContext {
    val: ValueExpression;
    _FLOAT: Token;
    _INTEGER: Token;
    _STRING: Token;
    _DATETIME: Token;
    FLOAT(): TerminalNode | undefined;
    INTEGER(): TerminalNode | undefined;
    STRING(): TerminalNode | undefined;
    DATETIME(): TerminalNode | undefined;
    TRUE(): TerminalNode | undefined;
    FALSE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class IdentifierContext extends ParserRuleContext {
    val: Identifier;
    _ID: Token;
    _NAME: Token;
    ID(): TerminalNode | undefined;
    NAME(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class ExpressionListContext extends ParserRuleContext {
    val: LogicalExpression[];
    _first: LogicalExpressionContext;
    _follow: LogicalExpressionContext;
    logicalExpression(): LogicalExpressionContext[];
    logicalExpression(i: number): LogicalExpressionContext;
    WS(): TerminalNode[];
    WS(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
export declare class ArgumentsContext extends ParserRuleContext {
    val: LogicalExpression[];
    _expressionList: ExpressionListContext;
    expressionList(): ExpressionListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: NCalcListener): void;
    exitRule(listener: NCalcListener): void;
    accept<Result>(visitor: NCalcVisitor<Result>): Result;
}
